"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IEntityTreeDriver = function () {
  /*
    @param {*} tree
  */

  function IEntityTreeDriver(tree) {
    _classCallCheck(this, IEntityTreeDriver);

    this._tree = tree;
  }

  /*
    @return {*} tree
  */


  _createClass(IEntityTreeDriver, [{
    key: "getTree",
    value: function getTree() {
      return this._tree;
    }

    /*
      @param {Array} path
      @return {*} tree
    */

  }, {
    key: "getInPath",
    value: function getInPath(path) {
      throw new Error("\n      getInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @param {Object} newValue
      @return {*} tree
    */

  }, {
    key: "updateInPath",
    value: function updateInPath(path, newValue) {
      throw new Error("\n      updateInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @return {*} tree
    */

  }, {
    key: "deleteInPath",
    value: function deleteInPath(path) {
      throw new Error("\n      deleteInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @param {Object} entity
      @return {*} tree
    */

  }, {
    key: "addInPath",
    value: function addInPath(path, entity) {
      throw new Error("\n      addInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }
  }]);

  return IEntityTreeDriver;
}();

exports.default = IEntityTreeDriver;